#ifndef _OPENDRIVE_COMMON_H
#define _OPENDRIVE_COMMON_H

#define DEFAULT_RESOLUTION        0.1
#define DEFAULT_SCALE_FACTOR      1.0
#define DEFAULT_MIN_ROAD_LENGTH   0.1

#include <map>

class COpendriveLane;
class COpendriveRoadNode;
class COpendriveRoadSegment;
class COpendriveSignal;
class COpendriveObject;
class COpendriveRoad;
class COpendriveLink;

typedef std::map<COpendriveRoadNode *,COpendriveRoadNode *> node_up_ref_t;
typedef std::map<COpendriveLane *,COpendriveLane *> lane_up_ref_t;
typedef std::map<COpendriveRoadSegment *,COpendriveRoadSegment *> segment_up_ref_t;
typedef std::map<COpendriveLink *,COpendriveLink *> link_up_ref_t;

typedef struct
{
  double s;
  double t;
  double heading;
}TOpendriveTrackPose;

typedef struct
{
  double u;
  double v;
  double heading;
}TOpendriveLocalPose;

typedef struct
{
  double x;
  double y;
  double heading;
}TOpendriveWorldPose;

typedef enum{OD_MARK_NONE,
             OD_MARK_SOLID,
             OD_MARK_BROKEN,
             OD_MARK_SOLID_SOLID,
             OD_MARK_SOLID_BROKEN,
             OD_MARK_BROKEN_SOLID,
             OD_MARK_BROKEN_BROKEN} opendrive_mark_t;

double normalize_angle(double angle);
double diff_angle(double angle1,double angle2);

#endif
